package ru.mai.dep806.mvcapp.aspects;

import com.sun.servicetag.SystemEnvironment;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.stereotype.Component;

/**
 * Created with IntelliJ IDEA.
 * User: Eugene
 * Date: 10.11.12
 * Time: 13:10
 * To change this template use File | Settings | File Templates.
 */
@Aspect
@Component
public class LoggingAspect {

//    @Around("execution(* ru.mai.dep806.mvcapp.dao.*.*(..))")
    @Around("@annotation(org.springframework.stereotype.Repository)")
    public Object logDaoMethods(ProceedingJoinPoint joinPoint) throws Throwable {
        long start = System.currentTimeMillis();
        try {
            return joinPoint.proceed();
        } finally {
            long time = System.currentTimeMillis() - start;
            System.out.println("Method called: " + joinPoint.getSignature()+ " took " + time);
        }
    }
}
