package ru.mai.dep806.mvcapp.services;

import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.mockito.ArgumentCaptor;
import org.mockito.internal.matchers.CapturingMatcher;
import ru.mai.dep806.mvcapp.ApplicationException;
import ru.mai.dep806.mvcapp.dao.UserDao;
import ru.mai.dep806.mvcapp.model.User;
import ru.mai.dep806.mvcapp.util.CryptoUtil;

import static junit.framework.Assert.assertEquals;
import static org.mockito.Mockito.*;

/**
 * Created with IntelliJ IDEA.
 * User: Eugene
 * Date: 03.11.12
 * Time: 13:28
 * To change this template use File | Settings | File Templates.
 */
@Ignore
public class AdminServiceTest {

    private UserDao userDao = mock(UserDao.class);

    @Before
    public void setUp() throws Exception {

    }

    @Test
    public void testRegisterUser_Success() throws Exception {
        AdminService adminService = new AdminService();

        adminService.setUserDao(userDao);

        User user = new User();
        user.setLogin("login");
        user.setName("name");
        adminService.registerUser(user, "12345");

        ArgumentCaptor<User> capturingMatcher = ArgumentCaptor.forClass(User.class);
        verify(userDao, times(1)).insertUser(capturingMatcher.capture());

        verifyNoMoreInteractions(userDao);

        assertEquals(capturingMatcher.getValue().getLogin(), "login");
        assertEquals(capturingMatcher.getValue().getName(), "name");
        assertEquals(capturingMatcher.getValue().getPasswordHash(), CryptoUtil.digestPassword("12345"));
    }

    @Test(expected = ApplicationException.class)
    public void testRegisterUser_InvalidPassword() throws Exception {
        AdminService adminService = new AdminService();

        User user = new User();

        adminService.registerUser(user, "123");
    }
}
